// DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DemoApp.h"
#include "DemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoAppDlg dialog

CDemoAppDlg::CDemoAppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoAppDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoAppDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	// Load images for tree control
	m_Images.Create(IDB_IMAGES, 16, 1, RGB(0,255,255)) ;
}

void CDemoAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoAppDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoAppDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoAppDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PLAY, OnPlay)
	ON_BN_CLICKED(IDC_PAUSE, OnPause)
	ON_BN_CLICKED(IDC_PLAYSTEP, OnPlaystep)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_SETNBR, OnSetNormalBirthRate)
	ON_BN_CLICKED(IDC_SETNDR, OnSetNormalDeathRate)
	ON_NOTIFY(NM_DBLCLK, IDC_VAR_TREE, OnDblclkVarTree)
	ON_EN_CHANGE(IDC_VAR_NAME, OnChangeVarName)
	//}}AFX_MSG_MAP
	// AK960320: Added line below to handle notifications from Powersim
   ON_MESSAGE(WM_COPYDATA, OnCopyData)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoAppDlg message handlers

BOOL CDemoAppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	// AK960320: Added Powersim Connection initialization
	if (!Open("..\\World5.sim", this->m_hWnd, TRUE))
		EndDialog(IDCANCEL) ;
	
	((CEdit*)GetDlgItem(IDC_NBR))->SetWindowText("0.04");
	((CEdit*)GetDlgItem(IDC_NDR))->SetWindowText("0.028");

	CTreeCtrl* pVarTree = (CTreeCtrl*)GetDlgItem(IDC_VAR_TREE) ;
	pVarTree->SetImageList(&m_Images, TVSIL_NORMAL) ;

	// Fill in the variables in the tree control
	FillVariableTree() ;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDemoAppDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemoAppDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemoAppDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// AK960320: Added handler for Powersim notifications

LRESULT CDemoAppDlg::OnCopyData(WPARAM wParam, LPARAM lParam)
// This function is necessary to receive Powersim notifications
{
   ASSERT(lParam);
   return Notify(lParam);
}


// AK960320: Added notification and event handlers below

void CDemoAppDlg::OnPlay() 
{
	Play(TRUE) ;
}

void CDemoAppDlg::OnPause() 
{
	Pause(!IsPaused());
}

void CDemoAppDlg::OnPlaystep() 
{
	PlayStep(1);
}

void CDemoAppDlg::OnStop() 
{
	Play(FALSE) ;
}

void CDemoAppDlg::OnSetNormalBirthRate() 
{
	char szNormalBirthRate[40];
	((CEdit*)GetDlgItem(IDC_NBR))->GetWindowText(szNormalBirthRate, 
		sizeof(szNormalBirthRate));

	double dbNormalBirthRate = atof(szNormalBirthRate);
	if (dbNormalBirthRate != 0.0)
		SetParValue(m_iNormalBirthRatePar, dbNormalBirthRate);
}

void CDemoAppDlg::OnSetNormalDeathRate() 
{
	char szNormalDeathRate[40];
	((CEdit*)GetDlgItem(IDC_NBR))->GetWindowText(szNormalDeathRate, 
		sizeof(szNormalDeathRate));

	double dbNormalDeathRate = atof(szNormalDeathRate);
	if (dbNormalDeathRate != 0.0)
		SetParValue(m_iNormalDeathRatePar, dbNormalDeathRate);
}

void CDemoAppDlg::NotifyOpenModel()
{
	m_iPopulationPar = AppendPar("P");
	m_iNormalBirthRatePar = AppendPar("BRN");
	m_iNormalDeathRatePar = AppendPar("DRN");
	m_iCustomPar = -1 ;
	OnChangeVarName() ;
}

void CDemoAppDlg::NotifyUpdateValues(BOOL bFinal)
{
	double dbTime = GetTime();
	char szTime[40];
	sprintf(szTime, "%.1f", dbTime);
	((CEdit*)GetDlgItem(IDC_TIME))->SetWindowText(szTime);

	double dbPopulation ; 
	GetParValue(m_iPopulationPar, &dbPopulation);
	char szPopulation[40];
	sprintf(szPopulation, "%.1f", dbPopulation);
	GetDlgItem(IDC_POPULATION)->SetWindowText(szPopulation);

	CString CustomValue ;
	if (m_iCustomPar >=0)
	{
		double dbCustom ;
		GetParValue(m_iCustomPar, &dbCustom);
		CustomValue.Format("%.1f", dbCustom) ;
	}
	else
		CustomValue.LoadString(IDS_UNDEFINED_VALUE) ;
	GetDlgItem(IDC_VAR_VALUE)->SetWindowText(CustomValue);
}

void CDemoAppDlg::NotifyPauseOn()
{
	((CButton*)GetDlgItem(IDC_PAUSE))->SetCheck(1);
}

void CDemoAppDlg::NotifyPauseOff()
{
	((CButton*)GetDlgItem(IDC_PAUSE))->SetCheck(0);
}

BOOL CDemoAppDlg::NotifyBeginSim()
{
	// SetParValue will only set values once in Powersim.
	// To use the values from the edit fields in the
	// following simulations, they must be set once per 
	// simulation. NotifyBeginSim is an appropriate place.
	OnSetNormalBirthRate() ;
	OnSetNormalDeathRate() ;
	return FALSE ; // Do not stop the simulation
}

void CDemoAppDlg::FillVariableTree()
{
	CTreeCtrl* pVarTree = (CTreeCtrl*)GetDlgItem(IDC_VAR_TREE) ;
	pVarTree->DeleteAllItems() ;

	// Model loop
	int cModels = GetModelCount() ;
	for (int iModel=0 ; iModel<cModels ; iModel++)
	{
		char szModelName[64] ;
		HTREEITEM hModelItem = pVarTree->InsertItem(
			GetModelName(iModel, szModelName, sizeof(szModelName))) ;
		if (!hModelItem)
			break ;
		pVarTree->SetItemData(hModelItem, MAKELONG((WORD)iModel, 0)) ;

		// Variable Loop
		int cVars = GetVariableCount(iModel) ;
		for (int iVar=0 ; iVar<cVars ; iVar++)
		{
			char szVarName[64] ;
			HTREEITEM hVariableItem = pVarTree->InsertItem(
				GetVariableName(iModel, iVar, szVarName, sizeof(szVarName)),
				hModelItem) ;
			if (!hVariableItem)
				break ;
			pVarTree->SetItemData(hVariableItem, MAKELONG((WORD)iVar, 1)) ;

			int VarType = GetVariableType(iModel, iVar) ;
			pVarTree->SetItemImage(hVariableItem, VarType, VarType) ;
			// Element loop
			int cElms = GetElementCount(iModel, iVar) ;
			for (int iElm=0 ; iElm<cElms ; iElm++)
			{
				char szElmName[512] ;
				HTREEITEM hElementItem = pVarTree->InsertItem(
					GetElementName(iModel, iVar, iElm, szElmName, sizeof(szElmName)),
					hVariableItem) ;
				if (!hElementItem)
					break ;
				pVarTree->SetItemData(hElementItem, MAKELONG((WORD)iElm, 2)) ;

				pVarTree->SetItemImage(hElementItem, 4, 4) ;
			} // element loop
		} // variable loop
		pVarTree->SortChildren(hModelItem) ;
	} // model loop

}

void CDemoAppDlg::OnDblclkVarTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CTreeCtrl* pVarTree = (CTreeCtrl*)GetDlgItem(IDC_VAR_TREE) ;
	HTREEITEM hSel = pVarTree->GetSelectedItem() ;
	if (!pVarTree->ItemHasChildren(hSel))
	{  // The node is a leaf, and hence an element
		// Assume it is an array element...
		HTREEITEM hElm = hSel ;
		HTREEITEM hVar = pVarTree->GetParentItem(hElm) ;
		ASSERT(hVar) ;
		HTREEITEM hModel = pVarTree->GetParentItem(hVar) ;
		if (!hModel)
		{  // ... Assumption was wrong
			hModel = hVar ;
			hVar = hSel ;
			hElm = NULL ;
		}
		// Build item name
		CString Name ;
		int iModel = LOWORD(pVarTree->GetItemData(hModel)) ;
		if (iModel)
		{
			Name = pVarTree->GetItemText(hModel) ;
			Name += "." ;
		}
		else
			Name = "" ;
		Name += pVarTree->GetItemText(hVar) ;
		if (hElm)
			Name += pVarTree->GetItemText(hElm) ;
		GetDlgItem(IDC_VAR_NAME)->SetWindowText(Name) ;
	}
	
	*pResult = 0;
}

void CDemoAppDlg::OnChangeVarName() 
/* Purpose: Add the necessary parameters and stuff due to change in
            variable name.
*/
{
	if (m_iCustomPar != -1)
		RemoveParAt(m_iCustomPar) ;

	CString VarName ;
	GetDlgItem(IDC_VAR_NAME)->GetWindowText(VarName) ;
	m_iCustomPar = AppendPar(VarName) ;
	if (m_iCustomPar >=0)
		NotifyUpdateValues(FALSE) ;
}
